Index: trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra.F90	(revision 2528)
@@ -34,7 +34,7 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -67,5 +67,7 @@
       NAMELIST/namtra_ldf/ ln_traldf_lap  , ln_traldf_bilap,                  &
          &                 ln_traldf_level, ln_traldf_hor  , ln_traldf_iso,   &
-         &                 rn_aht_0       , rn_ahtb_0      , rn_aeiv_0
+         &                 ln_traldf_grif , ln_traldf_gdia,                   &
+         &                 rn_aht_0       , rn_ahtb_0      , rn_aeiv_0,       &
+         &                 rn_slpmax
       !!----------------------------------------------------------------------
 
@@ -80,10 +82,19 @@
          WRITE(numout,*) 'ldf_tra_init : lateral tracer physics'
          WRITE(numout,*) '~~~~~~~~~~~~ '
-         WRITE(numout,*) '   Namelist namtra_ldf : lateral mixing coefficients'
+         WRITE(numout,*) '   Namelist namtra_ldf : lateral mixing parameters (type, direction, coefficients)'
          WRITE(numout,*) '      laplacian operator            ln_traldf_lap   = ', ln_traldf_lap
          WRITE(numout,*) '      bilaplacian operator          ln_traldf_bilap = ', ln_traldf_bilap
+         WRITE(numout,*) '      iso-level                     ln_traldf_level = ', ln_traldf_level
+         WRITE(numout,*) '      horizontal (geopotential)     ln_traldf_hor   = ', ln_traldf_hor
+         WRITE(numout,*) '      iso-neutral                   ln_traldf_iso   = ', ln_traldf_iso
+         WRITE(numout,*) '      iso-neutral (Griffies)        ln_traldf_grif  = ', ln_traldf_grif
+         WRITE(numout,*) '      Griffies strmfn diagnostics   ln_traldf_gdia  = ', ln_traldf_gdia
          WRITE(numout,*) '      lateral eddy diffusivity      rn_aht_0        = ', rn_aht_0
          WRITE(numout,*) '      background hor. diffusivity   rn_ahtb_0       = ', rn_ahtb_0
          WRITE(numout,*) '      eddy induced velocity coef.   rn_aeiv_0       = ', rn_aeiv_0
+         WRITE(numout,*) '      maximum isoppycnal slope      rn_slpmax       = ', rn_slpmax
+         WRITE(numout,*) '   + griffies operator internal controls not set via the namelist (experimental): '
+         WRITE(numout,*) '      calculate triads twice        l_triad_iso     = ', l_triad_iso
+         WRITE(numout,*) '      no Shapiro filter             l_no_smooth     = ', l_no_smooth
          WRITE(numout,*)
       ENDIF
Index: trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_c1d.h90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_c1d.h90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_c1d.h90	(revision 2528)
@@ -4,7 +4,7 @@
 
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_c2d.h90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_c2d.h90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_c2d.h90	(revision 2528)
@@ -4,7 +4,7 @@
 
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_c3d.h90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_c3d.h90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_c3d.h90	(revision 2528)
@@ -4,7 +4,7 @@
 
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_oce.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_oce.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_oce.F90	(revision 2528)
@@ -20,9 +20,14 @@
    LOGICAL , PUBLIC ::   ln_traldf_hor   = .FALSE.   !: horizontal (geopotential) direction
    LOGICAL , PUBLIC ::   ln_traldf_iso   = .TRUE.    !: iso-neutral direction
+   LOGICAL , PUBLIC ::   ln_traldf_grif  = .FALSE.   !: griffies skew flux
+   LOGICAL , PUBLIC ::   ln_traldf_gdia  = .FALSE.   !: griffies skew flux streamfunction diagnostics
    REAL(wp), PUBLIC ::   rn_aht_0        = 2000._wp  !: lateral eddy diffusivity (m2/s)
    REAL(wp), PUBLIC ::   rn_ahtb_0       =    0._wp  !: lateral background eddy diffusivity (m2/s)
    REAL(wp), PUBLIC ::   rn_aeiv_0       = 2000._wp  !: eddy induced velocity coefficient (m2/s)
+   REAL(wp), PUBLIC ::   rn_slpmax       = 0.01_wp   !: slope limit
 
    REAL(wp), PUBLIC ::   aht0, ahtb0, aeiv0         !!: OLD namelist names
+   LOGICAL , PUBLIC ::   l_triad_iso     = .FALSE.   !: calculate triads twice
+   LOGICAL , PUBLIC ::   l_no_smooth     = .FALSE.   !: no Shapiro smoothing
 
 #if defined key_traldf_c3d
@@ -41,5 +46,5 @@
    !!   'key_traldf_eiv'                              eddy induced velocity
    !!----------------------------------------------------------------------
-   LOGICAL, PUBLIC, PARAMETER ::   lk_traldf_eiv   = .TRUE.   !: eddy induced velocity flag
+   LOGICAL, PUBLIC, PARAMETER               ::   lk_traldf_eiv   = .TRUE.   !: eddy induced velocity flag
       
 # if defined key_traldf_c3d
@@ -65,7 +70,7 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!=====================================================================
 END MODULE ldftra_oce
Index: trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_substitute.h90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_substitute.h90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_substitute.h90	(revision 2528)
@@ -6,7 +6,7 @@
    !!----------------------------------------------------------------------
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 #if defined key_traldf_c3d
Index: trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obc_oce.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obc_oce.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obc_oce.F90	(revision 2528)
@@ -231,7 +231,7 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================
 END MODULE obc_oce
Index: trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obc_par.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obc_par.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obc_par.F90	(revision 2528)
@@ -21,7 +21,7 @@
    PUBLIC
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 #if ! defined key_agrif
Index: trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obc_par_EEL_R5.h90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obc_par_EEL_R5.h90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obc_par_EEL_R5.h90	(revision 2528)
@@ -5,7 +5,7 @@
    !!---------------------------------------------------------------------
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
    INTEGER, PARAMETER ::     &  !: time dimension for the BCS fields on input
Index: trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obc_par_POMME_R025.h90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obc_par_POMME_R025.h90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obc_par_POMME_R025.h90	(revision 2528)
@@ -4,4 +4,9 @@
    !! open boundary parameter : POMME configuration
    !!---------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
    INTEGER, PARAMETER ::  jptobc  =	      14   
    !: time dimension of the BCS fields on input
Index: trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obc_vectopt_loop_substitute.h90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obc_vectopt_loop_substitute.h90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obc_vectopt_loop_substitute.h90	(revision 2528)
@@ -5,10 +5,5 @@
    !!      to allow unrolling of do-loop using CPP macro.
    !!----------------------------------------------------------------------
-   !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
-   !!----------------------------------------------------------------------
-#if defined key_vectopt_loop && defined key_obc && ! defined key_mpp_mpi && ! defined key_mpp_shmem
+#if defined key_vectopt_loop && defined key_obc && ! defined key_mpp_mpi
 #  define fs_niw0  jpiwob 
 #  define fs_niw1  jpiwob
@@ -29,2 +24,7 @@
 #  define fs_njs1  njs1
 #endif
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$ 
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
Index: trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obcdta.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obcdta.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obcdta.F90	(revision 2528)
@@ -83,7 +83,7 @@
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2006)
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obcdyn_bt.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obcdyn_bt.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obcdyn_bt.F90	(revision 2528)
@@ -34,7 +34,7 @@
 
    !!---------------------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obcini.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obcini.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obcini.F90	(revision 2528)
@@ -31,7 +31,7 @@
 #  include "obc_vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -437,4 +437,13 @@
          END DO
       END IF
+
+      IF( lp_obc_west ) THEN ! ... West open boundary lateral surface
+         DO ji = niw0, niw1
+            DO jj = 1, jpj 
+               obcsurftot = obcsurftot+hu(ji,jj)*e2u(ji,jj)*uwmsk(jj,1) * MAX(obctmsk(ji,jj),obctmsk(ji+1,jj) )
+            END DO
+         END DO
+      END IF
+
       IF( lp_obc_north ) THEN ! ... North open boundary lateral surface
          DO jj = njn0, njn1
Index: trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obcrad.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obcrad.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obcrad.F90	(revision 2528)
@@ -42,7 +42,7 @@
 #  include "obc_vectopt_loop_substitute.h90"
    !!---------------------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!---------------------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obcrst.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obcrst.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obcrst.F90	(revision 2528)
@@ -24,7 +24,7 @@
 
    !!---------------------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!---------------------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obctra.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obctra.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obctra.F90	(revision 2528)
@@ -46,7 +46,7 @@
 #  include "obc_vectopt_loop_substitute.h90"
    !!---------------------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!---------------------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obcvol.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obcvol.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/OBC/obcvol.F90	(revision 2528)
@@ -28,7 +28,7 @@
 #  include "obc_vectopt_loop_substitute.h90"
    !!---------------------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!---------------------------------------------------------------------------------
 
@@ -97,5 +97,5 @@
       ! ---------------------------------------------------------------------------
 
-      zCflxemp = SUM ( emp(:,:)*obctmsk(:,:)* e1t(:,:) * e2t(:,:)  / rau0 )
+      zCflxemp = SUM ( ( emp(:,:)-rnf(:,:) )*obctmsk(:,:)* e1t(:,:) * e2t(:,:)  / rau0 ) 
 
       IF( lk_mpp )   CALL mpp_sum( zCflxemp )   ! sum over the global domain
Index: trunk/NEMOGCM/NEMO/OPA_SRC/OBS/ddatetoymdhms.h90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/OBS/ddatetoymdhms.h90	(revision 2528)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/OBS/ddatetoymdhms.h90	(revision 2528)
@@ -0,0 +1,43 @@
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+   SUBROUTINE ddatetoymdhms( ddate, kyea, kmon, kday, khou, kmin, ksec )
+      !!----------------------------------------------------------------------
+      !!
+      !!                    *** ROUTINE ddatetoymdhms ***
+      !!
+      !! ** Purpose : Convert YYYYMMDD.hhmmss to components
+      !!
+      !! ** Method  :
+      !!
+      !! ** Action  :
+      !!
+      !! History
+      !!----------------------------------------------------------------------
+      !! * Modules used
+
+      !! * Arguments
+      REAL(dp), INTENT(IN) :: ddate
+      INTEGER, INTENT(OUT) :: kyea
+      INTEGER, INTENT(OUT) :: kmon
+      INTEGER, INTENT(OUT) :: kday
+      INTEGER, INTENT(OUT) :: khou
+      INTEGER, INTENT(OUT) :: kmin
+      INTEGER, INTENT(OUT) :: ksec
+      !! * Local declarations
+      INTEGER :: iyymmdd
+      INTEGER :: ihhmmss
+      
+      iyymmdd = INT( ddate )
+      ihhmmss = INT( ( ddate - iyymmdd ) * 1000000 )
+      kyea = iyymmdd/10000
+      kmon = iyymmdd / 100 - 100 * kyea
+      kday = MOD( iyymmdd, 100 )
+      khou = ihhmmss/10000
+      kmin = ihhmmss / 100 - 100 * khou
+      ksec = MOD( ihhmmss, 100 )
+      
+   END SUBROUTINE ddatetoymdhms
